/**
 * @brief Simple Malloc allocator
 **/

/*
 * This file is subject to the license agreement located in the file LICENSE
 * and cannot be distributed without it. This notice cannot be
 * removed or modified.
 */

#ifndef __MEM_PLATFORM_MALLOC_H__
#define __MEM_PLATFORM_MALLOC_H__

#include "ocr-config.h"
#ifdef ENABLE_MEM_PLATFORM_MALLOC

#include "debug.h"
#include "utils/rangeTracker.h"
#include "ocr-mem-platform.h"
#include "ocr-types.h"
#include "utils/ocr-utils.h"

typedef struct {
    ocrMemPlatformFactory_t base;
} ocrMemPlatformFactoryMalloc_t;

typedef struct {
    ocrMemPlatform_t base;
    rangeTracker_t *pRangeTracker;
    u32 lock;
} ocrMemPlatformMalloc_t;

ocrMemPlatformFactory_t* newMemPlatformFactoryMalloc(ocrParamList_t *perType);

#endif /* ENABLE_MEM_PLATFORM_MALLOC */
#endif /* __MEM_PLATFORM_MALLOC_H__ */
